;**************************************************************************
; Diverse Wartefunktionen
; alle auf F_CPU = 4,8MHz ausgelegt
; bei anderer F_CPU muss man 
;
; warte_Nx10us, warte_4us, warte_2us
;
; manuell anpassen!
;**************************************************************************


;**************************************************************************
warte_Nx1ms:                            ; Warte N x 1ms
; Parameter: temp2: Anzahl N
; -------------------------------------------------------------------------
    push    temp3
    mov     temp3, temp2
warte_Nx1ms_schleife:
    ldi     temp2, 100
    rcall   warte_Nx10us
    dec     temp3
    brne    warte_Nx1ms_schleife
    pop     temp3
    ret

;**************************************************************************
warte_480us:
; -------------------------------------------------------------------------
    ldi     temp2, 48
warte_Nx10us:                           ; Warte N x 10us
; Parameter: temp2: Anzahl N
; -------------------------------------------------------------------------
                                        ; 3 Takte fr rcall beim Aufruf
warte_Nx10us_schleife_N:
    ldi     temp_warte, 9               ; 1 Takt
warte_Nx10us_schleife_10us:
    nop
    nop
    dec     temp_warte
    brne    warte_Nx10us_schleife_10us  ; innere Schleife dauert 5x9=45 Takte
    dec     temp2
    brne    warte_Nx10us_schleife_N     ; +3 = 48 Takte  = 10us fr uere Schleife @4,8MHz
    ret                                 ; 4 Takte 
                                        ; Summe 8+n*48 Takte = 2us+N*10us
                                                    
;**************************************************************************
warte_4us:
;--------------------------------------------------------------------------
    lpm                                 ; lpm(3), Takte verschwenden mit minimalem Code
    lpm                                 ; lpm(3)    
    lpm                                 ; lpm(3)
warte_2us:                              ; rcall(3) + ret(4) + 2x nop(1) = 9 Takte ~2us
;--------------------------------------------------------------------------
    nop
    nop
    ret 

;**************************************************************************
warte_5s_taste:                         ; 5s warten, Abbruch mit Taste
;--------------------------------------------------------------------------
    ldi     temp0, 50
warte_5s_Taste_schleife:
    ldi     temp2, 100
    rcall   warte_Nx1ms
    sbis    PINB, Taste                 ; springe, wenn Taste nicht gedrckt (Taste ist low active) 
    ldi     temp0, 1                    ; Schleifenzhler direkt auf letzten Durchlauf setzen
    dec     temp0
    brne    warte_5s_taste_schleife
    ret

; *********************************************************************************
warte_2s:
;----------------------------------------------------------------------------------
    ldi     temp0, 20
warte_2s_schleife:
    ldi     temp2, 100
    rcall   warte_Nx1ms
    dec     Temp0
    brne    warte_2s_schleife
    ret
